/* Color value functions
---------------------------------------------------------------------
Program : funColor.prg
Programmer : Greg Brzozowski GM+ (gmplus@interia.pl)
Last Modified : 02/11/2001
Notes :  color value functions
Rev. History : 02/11/2001 -- Original

Instantiation :
 
   set procedure to funStruct.prg additive
   set procedure to funColor.prg additive

--------------------------------------  */


  //#define LOBYTE(n)  (bitand((n),0xFF))
  //#define RGB(r,g,b)   (bitor(bitor(LOBYTE(r),bitlshift(LOBYTE(g),8)),bitlshift(LOBYTE(b),16)))

  
  Procedure TranslateColor( cString, num)
 ************************************************
   Local sp 
   Private col

    if not Empty( cString)       
       col = Upper( Ltrim( Rtrim( cString)))
       sp = At( '/', col, 1) 

       if argcount() = 1 or num = 1
          col = iif( sp > 0, Rtrim( Left( col, sp -1)), cString)
       elseif sp > 0 and num = 2 
          col = Ltrim( Right( col, Len( col) -sp))  
       else
          Return null
       endif          
       if Empty( col)
          Return null
       endif 

       Return iif( Isalpha( col), GetSysNameColor( col), &col.)     
     endif

     Return null
   


   Procedure LumColor( nCol, nPerc)
  *************************************************************** 
  // nPerc : -100..0..100
  
   Local nR, nG, nB, cP, nPos

   nPos = 1 -( Abs( nPerc) *0.01)
   cP = iif( nPerc > 0, 0xFF, 0) 
   cR = cP +( Bitand( nCol, 0xFF) -cP) *nPos
   cG = cP +( Int( Bitand( nCol, 0xFF00) / 0x100) -cP) *nPos  
   cB = cP +( Int( Bitand( nCol, 0xFF0000) / 0x10000) -cP) *nPos 

   Return Bitand( cR, 0xFF);
              +Bitand( cG, 0xFF) *0x100;
              +Bitand( cB, 0xFF) *0x10000       



   Procedure RGB( r, g, b)
  ****************************************** 
   Return bitor( bitor( mod( r, 2^8),;
               bitlshift( mod( g, 2^8), 8)),;
               bitlshift( mod( b, 2^8), 16))
 

         
  Procedure GetSysNameColor( cstring)
 ************************************************    
  Do Case
        Case cstring == [ACTIVEBORDER]; cstring = 10	//	Active window border
		  Case cstring == [ACTIVECAPTION]; cstring = 2	//	Active title bar
		  Case cstring == [APPWORKSPACE]; cstring =12 	//	Application background
		  Case cstring == [BACKGROUND]; cstring = 1	//	Desktop
		  Case cstring == [BTNFACE]; cstring = 15	//	3D objects
		  Case cstring == [BTNHIGHLIGHT]; cstring = 20	//	A shade lighter than 3D objects
		  Case cstring == [BTNSHADOW]; cstring = 16	//	A shade darker than 3D objects
		  Case cstring == [BTNTEXT]; cstring = 18	//	3D objects font
		  Case cstring == [CAPTIONTEXT]; cstring = 9	//	Active title bar font
		  Case cstring == [GRAYTEXT]; cstring = 17	//	preset gray-not available
		  Case cstring == [HIGHLIGHT]; cstring = 13	//	Selected items
		  Case cstring == [HIGHLIGHTTEXT]; cstring = 14	//	Selected items font
		  Case cstring == [INACTIVEBORDER]; cstring = 11	//	Inactive window border
		  Case cstring == [INACTIVECAPTION]; cstring = 3	//	Inactive title bar
		  Case cstring == [INACTIVECAPTIONTEXT]; cstring = 19	//	Inactive title bar font
		  Case cstring == [INFOTEXT]; cstring = 23	//	ToolTip
		  Case cstring == [INFOBK]; cstring = 24	//	ToolTip font
		  Case cstring == [MENU]; cstring = 4	//	Menu
		  Case cstring == [MENUTEXT]; cstring = 7	//	Menu font
		  Case cstring == [SCROLLBAR]; cstring = 0	//	A shade lighter than 3D objects
		  Case cstring == [WINDOW]; cstring = 5	//	Window
		  Case cstring == [WINDOWFRAME]; cstring = 6	//	preset drop shadow-not available
		  Case cstring == [WINDOWTEXT]; cstring = 8	//	Window font          
        Case cstring == [COLOR_3DDKSHADOW]; cstring = 21
		  Case cstring == [COLOR_3DLIGHT]; cstring = 22     
        Otherwise; cstring = 0
 EndCase
 Return iif( cstring > 0, GetSysColor( cstring), null)
  


 
   Procedure GetRGB( r, g, b)
  ****************************************** 
   Return bitor( bitor( mod( r, 2^8),;
               bitlshift( mod( g, 2^8), 8)),;
               bitlshift( mod( b, 2^8), 16))
 
