// MemStat.CC
/*

   Author: Jim Sare (jimsare@ameritech.net)
   Notes.: API Calls to get information about
           the memory status ...

   See also: TESTGMS.PRG which shows how to 
             use this.
  
*/
CLASS stMEMORYSTATUS Of String

   this.String := Replicate(Chr(0), 16)

   PROTECT GetU32

   FUNCTION GetU32(nIndex)

      RETURN this.GetByte(nIndex) +;
             BitLShift(this.GetByte(nIndex + 1),  8) +;
             BitLShift(this.GetByte(nIndex + 2), 16) +;
             BitLShift(this.GetByte(nIndex + 3), 24)

   FUNCTION dwLength

      RETURN this.GetU32(0)

   FUNCTION dwMemoryLoad(n)

      RETURN this.GetU32(4)

   FUNCTION dwTotalPhys(n)

      RETURN this.GetU32(8)

   FUNCTION dwAvailPhys(n)

      RETURN this.GetU32(12)

   FUNCTION dwTotalPageFile(n)

      RETURN this.GetU32(16)

   FUNCTION dwAvailPageFile(n)

      RETURN this.GetU32(20)

   FUNCTION dwTotalVirtual(n)

      RETURN this.GetU32(24)

   FUNCTION dwAvailVirtual(n)

      RETURN this.GetU32(28)

   PROCEDURE Logout

      ? "dwLength:        " + this.dwLength()
      ? "dwMemoryLoad:    " + this.dwMemoryLoad()
      ? "dwTotalPhys:     " + this.dwTotalPhys()
      ? "dwAvailPhys:     " + this.dwAvailPhys()
      ? "dwTotalPageFile: " + this.dwTotalPageFile()
      ? "dwAvailPageFile: " + this.dwAvailPageFile()
      ? "dwTotalVirtual:  " + this.dwTotalVirtual()
      ? "dwAvailVirtual:  " + this.dwAvailVirtual()

ENDCLASS  // stMEMORYSTATUS Of String
