*-----------------------------------------------------------------------
* Program : csSrcFx.cc
* Programmer : Greg Brzozowski GM+ (gmplus@o2.pl)
* Last Modified: 01/09/2004
* Description: 
*-----------------------------------------------------------------------




class ColorSourceCtrl
***************************************************
this.className = "COLORSOURCECTRL"


   function getColor(cSource,iNum)
   ************************************************
   #include csSrcFx.h 

   local sep 
   private color

   if not empty(cSource) 
         
      color = upper(ltrim(rtrim(cSource)))
      sep = at('/',color,1) 

      if argcount() = 1 or iNum = 1
       	color = iif(sep > 0,rtrim(left(color,sep - 1)),cSource)
      elseif sep > 0 and iNum = 2 
       	color = ltrim(right(color,len(color) - sep))  
      else
       	return CLR_DEFAULT
      endif
              
      if empty(color) 
         return CLR_DEFAULT
      endif

      if isalpha(color)
         return ColorSourceCtrl::getSysColor(color)	
      endif

      return &color.   
        
   endif

   return CLR_DEFAULT

        
   function getSysColor(cSource)
   ************************************************ 
   local nCol
  
   do case
      case cSource == "SCROLLBAR"           ;nCol = COLOR_SCROLLBAR
      case cSource == "BACKGROUND"          ;nCol = COLOR_BACKGROUND
      case cSource == "ACTIVECAPTION"       ;nCol = COLOR_ACTIVECAPTION
      case cSource == "INACTIVECAPTION"     ;nCol = COLOR_INACTIVECAPTION
      case cSource == "MENU"                ;nCol = COLOR_MENU
      case cSource == "WINDOW"              ;nCol = COLOR_WINDOW
      case cSource == "WINDOWFRAME"         ;nCol = COLOR_WINDOWFRAME
      case cSource == "MENUTEXT"            ;nCol = COLOR_MENUTEXT
      case cSource == "WINDOWTEXT"          ;nCol = COLOR_WINDOWTEXT
      case cSource == "CAPTIONTEXT"         ;nCol = COLOR_CAPTIONTEXT
      case cSource == "ACTIVEBORDER"        ;nCol = COLOR_ACTIVEBORDER
      case cSource == "INACTIVEBORDER"      ;nCol = COLOR_INACTIVEBORDER
      case cSource == "APPWORKSPACE"        ;nCol = COLOR_APPWORKSPACE
      case cSource == "HIGHLIGHT"           ;nCol = COLOR_HIGHLIGHT
      case cSource == "HIGHLIGHTTEXT"       ;nCol = COLOR_HIGHLIGHTTEXT
      case cSource == "BTNFACE"             ;nCol = COLOR_BTNFACE
      case cSource == "BTNSHADOW"           ;nCol = COLOR_BTNSHADOW
      case cSource == "GRAYTEXT"            ;nCol = COLOR_GRAYTEXT
      case cSource == "BTNTEXT"             ;nCol = COLOR_BTNTEXT
      case cSource == "INACTIVECAPTIONTEXT" ;nCol = COLOR_INACTIVECAPTIONTEXT
      case cSource == "BTNHIGHLIGHT"        ;nCol = COLOR_BTNHIGHLIGHT
      case cSource == "3DDKSHADOW"          ;nCol = COLOR_3DDKSHADOW
      case cSource == "3DLIGHT"             ;nCol = COLOR_3DLIGHT
      case cSource == "INFOTEXT"            ;nCol = COLOR_INFOTEXT
      case cSource == "INFOBK"              ;nCol = COLOR_INFOBK
      case cSource == "DESKTOP"             ;nCol = COLOR_BACKGROUND
      case cSource == "3DFACE"              ;nCol = COLOR_BTNFACE
      case cSource == "3DSHADOW"            ;nCol = COLOR_BTNSHADOW
      case cSource == "3DHIGHLIGHT"         ;nCol = COLOR_BTNHIGHLIGHT
      case cSource == "3DHILIGHT"           ;nCol = COLOR_BTNHIGHLIGHT
      case cSource == "BTNHILIGHT"          ;nCol = COLOR_BTNHIGHLIGHT
      otherwise
   		return CLR_DEFAULT
 	endcase
  
   if type("WINAPI_GetSysColor") # "FP"   
   	extern CINT WINAPI_GetSysColor(CINT) user32 from "GetSysColor"
   endif

   return WINAPI_GetSysColor(nCol)



  function setLumColor(nCol,nPerc)
  ******************************************
  // nPerc : -100..0..100
  
   local nR,nG,nB,cP,nPos

   nPos = 1 - (abs(nPerc) *0.01)
   cP = iif(nPerc > 0,0xFF, 0) 
   cR = cP +(bitand(nCol,0xFF) -cP) *nPos
   cG = cP +(int(bitand(nCol,0xFF00) / 0x100) -cP) *nPos  
   cB = cP +(int(bitand(nCol,0xFF0000) / 0x10000) -cP) *nPos 

   return bitand(cR,0xFF) + bitand(cG,0xFF) *0x100 + bitand(cB,0xFF) *0x10000       


   function getRGB(r,g,b)
   ****************************************** 
   return bitor(bitor(mod(r,2^8),bitlshift(mod(g,2^8),8)),bitlshift(mod(b,2^8),16))
 
     
endclass





class ImageSourceCtrl
***************************************************
this.className = "IMAGESOURCECTRL"



	function getHandle(cSource,nSize)
  	*********************************************     
   #include csSrcFx.h

	local str,nType,fuLoad,hImage
   nType = IMAGE_BITMAP 
   hImage = 0

   if not empty(cSource) 

   	if type("WINAPI_LoadImage") # "FP"   
    		extern CHANDLE WINAPI_LoadImage(CHANDLE,CSTRING,CUINT,CINT,CINT,CUINT) user32 from "LoadImageA"
		endif

      if type("WINAPI_LoadLibrary") # "FP"  
    		extern CHANDLE WINAPI_LoadLibrary(CSTRING) kernel32 from "LoadLibraryA"
		endif

      if type("argvector(2)") == "U" or nSize = 0 
         fuLoad = bitor(LR_DEFAULTSIZE,fuLoad)
         nSize = 0
      else
      	fuLoad = 0
      endif
 
      str = upper(ltrim(rtrim(cSource)))    
         
      if left(str,8) == "FILENAME"

      	 fuLoad = bitor(LR_LOADFROMFILE,fuLoad)

          str = ltrim(stuff(str,1,8,""))

           if right( str, 4) == ".BMP"  
              nType = IMAGE_BITMAP 

           elseif right(str,4) == ".ICO"           
           	  nType = IMAGE_ICON	
               
           endif

           hImage = WINAPI_LoadImage(null,str,nType,nSize,nSize,fuLoad)

      elseif left(str,8) == "RESOURCE"

           str = upper(ltrim(stuff(str,1,8,"")))
      
           if left(str,4) == "ICON"
           	  str = ltrim(stuff(str,1,4,""))
              nType = IMAGE_ICON	

           elseif left(str,6) == "BITMAP"
           	  str = ltrim(stuff(str,1,6,""))
              nType = IMAGE_BITMAP		

           endif

           local sp,cLib,hLib 

           sp = at(" ",str,1) 
           cLib = iif(sp > 0,ltrim(right(str,len(str) - sp)),;
           							_dbwinhome + "BIN\RESOURCE.DLL") 
           hLib = WINAPI_LoadLibrary(cLib)         
           str = iif(sp > 0,ltrim(left(str,sp)),str)

           hImage = WINAPI_LoadImage(hLib,str,nType,nSize,nSize,fuLoad)

      endif

    endif

    return hImage


 endclass


