/*
    -----------------------------------------------------------
    custbuttFrench.h
    February 25, 1999
    Ken Mayer
    French Translation of "custButtEnglish.h" 
       by Jean-Pierre Martel and Franois Ghoche

     *** Note: you should copy this file to your
     ..\Visual dBASE\INCLUDE directory for it to
     be used properly by all of your applications.

    This is an 'include' file with the speedTips and
    message box text for each of the buttons in CUSTBUTT.CC.
    The idea is that by defining them here, someone using
    another language can copy this file and translate the
    text in the .H file, and the only change necessary in
    CUSTBUTT.CC is the #INCLUDE statement to include
    the correct file.

    When translating, make sure you do NOT change the names
    of the constants ...

    *****************
    November 11, 2000
    *****************
    NOTE: If you update your application to use the 
    CUSTBUTT.CC file from dUFLP version 2KC (DUFLP2KC.EXE),
    then you MUST update your .H file -- this is a fix based
    on a discovery that EMPTYTABLE and FILTER strings could
    cause problem in code that used the database object
    emptyTable method, or the rowset object's filter property.
    These strings are defined as EMPTYTABLETEXT and FILTERTEXT
    now, and will not cause a conflict.

    Suggestion by Francesco Navarria, in Italy ...
    **********************************************************
    *** WARNING: If you are not using an ANSI language driver
    *** for your tables (at the Command window: ? LDRIVER()
    *** it should be obvkous) or have the setting:
    ***  LDRIVER=WINDOWS in your VDB.INI file (under the
    *** [CommandSettings] heading) do NOT attempt save
    *** this file ... you can wipe out the upper ANSI characters
    *** used. 
    **********************************************************
    -----------------------------------------------------------
*/

// ----------------------------------------------------------
// navigation buttons:
                                //"First row in rowset"
#define TOPTIP                  "Premire ligne du rowset"
                                //"Previous row in rowset"
#define PREVTIP                 "Ligne prcdente du rowset"
                                 //"Next row in rowset"
#define NEXTTIP                 "Ligne suivante du rowset"
                                //"Last row in rowset"
#define ENDTIP                  "Dernire ligne du rowset"

// ----------------------------------------------------------
// editing buttons:
                                //"Add new row"
#define ADDTIP                  "Ajouter une ligne"
                                //"Copy data to a new Row"
#define CARRYTIP                "Copier dans une nouvelle ligne"
                                //"Edit current row"
#define EDITTIP                 "Modifier la ligne"
                                //"Save current row"
#define SAVETIP                 "Sauvegarder la ligne"
                                //"Delete current row"
#define DELETETIP               "Supprimer la ligne"
                                //"Abandon changes to row"
#define ABANDONTIP              "Annuler les changements"

// ----------------------------------------------------------
// filter/locate buttons:
                                //"Filter/Run/Clear Filter"
#define FILTERTIP               "Dfinir, Appliquer, Annuler le filtre"
                                //"Locate/Run/Clear Locate"
#define LOCATETIP               "Dfinir, Excuter, Annuler la recherche"

// ----------------------------------------------------------
// clipboard buttons:
                                //"Cut selected text"
#define CUTTIP                  "Couper"
                                //"Copy selected text"
#define COPYTIP                 "Copier"
                                //"Paste from clipboard"
#define PASTETTIP               "Coller"

// ----------------------------------------------------------
// misc. buttons:
                                //"Close this form"
#define CLOSETIP                "Fermer le formulaire"
                                //"Yes"
#define YESTIP                  "Oui"
                                //"No"
#define NOTIP                   "Non"
                                //"Cancel"
#define CANCELTIP               "Annuler"
                                //"Question? Help?"
#define QUESTIONTIP             "Question? Aide?"
                                //"Run"
#define RUNTIP                  "Excuter"
                                //"Information"
#define INFOTIP                 "Information"
                                //"Restore from disk"
#define RESTOREFROMDISKTIP      "Revenir  la copie sauvegarde"
                                //"Save to disk"
#define SAVETODISKTIP           "Sauvegarder"
                                //"Open file ..."
#define OPENFILETIP             "Ouvrir..."
                                //"Tool Button"
#define TOOLBUTTONTIP           "Outils"
                                //"Print"
#define PRINTTIP                "Imprimer"
                                //"Search"
#define SEARCHTIP               "Rechercher"
                                //"Continue search"
#define SEARCHAGAINTIP          "Poursuivre la recherche"
                                //"Replace"
#define REPLACETIP              "Remplacer"
                               //"Exit"
#define EXITTIP                 "Quitter"
                                //"First Page"
#define FIRSTPAGETIP            "Premire page"
                                //"Next Page"
#define NEXTPAGETIP             "Page suivante"
                                //"Previous Page"
#define PREVIOUSPAGETIP         "Page prcdente"
                                //"The Light Goes Off"
#define LIGHTBULBTIP            "La lumire s'teint"


// ----------------------------------------------------------
// strings used in dialog boxes in CUSTBUTT.CC
// ----------------------------------------------------------

// This one appears as the title for various dialogs
                                //"Can't do it!"            
#define CANTDOIT                " Ceci est interdit !"

// ----------------------------------------------------------
// One of these appears anytime we check to see if the rowset
// is null, and is the text in the messagebox
                                //"Cannot Navigate with no rowset!"
#define NAVNOROWSET             "Impossible de changer de ligne sans rowset !"
                                //"Cannot add rows with no rowset!"
#define ADDNOROWSET             "Impossible d'ajouter une ligne sans rowset !"
                                //"Cannot copy rows on a form without a rowset!"
#define COPYNOROWSET            "Impossible de copier une ligne sans rowset !"
                                //"Cannot update rows on a form without a rowset!"
#define EDITNOROWSET            "Impossible de modifier une ligne sans rowset !"
                                //"Cannot save changes to rows on a form without a rowset!"
#define SAVENOROWSET            "Impossible de sauvegarder une ligne sans rowset !"
                                //"Cannot delete rows on a form without a rowset!"
#define DELETENOROWSET          "Impossible de supprimer une ligne sans rowset !"
                                //"Cannot abandon changes to rows on a form without a rowset!"
#define ABANDONNOROWSET         "Impossible d'annuler des changements sans rowset !"
                                //"Cannot filter an empty or missing rowset!"
#define FILTERNOROWSET          "Impossible de filtrer un rowset inexistant ou vide !"
                                //"Cannot perform a locate with no rowset!"
#define LOCATENOROWSET          "Pas de recherche squentielle possible sans rowset !"

// ----------------------------------------------------------
// this is the title and message when the user attempts
// to navigate or close a form and the data has
// changed ...
                                //"Data has changed"
#define DATACHANGED             "Les donnes ont t modifies"
                                //"Save changes before leaving record?"
#define SAVECHANGES             "Doit-on sauvegarder les modifications ?"

// ----------------------------------------------------------
// Title when user can't navigate:
                                //"Can't Navigate!"
#define CANTNAVIGATE            "Navigation interdite !"

// ----------------------------------------------------------
// Other messages ...
                                //"You are in filter mode"
#define INFILTERMODE            "Vous tes en train de filtrer"
                                //"You are in locate mode"
#define INLOCATEMODE            "Vous tes en recherche squentielle"
                                //"At first row in rowset"
#define ATFIRSTROW              "Vous tes  la premire ligne du rowset"
                                //"At last row in rowset"
#define ATLASTROW               "Vous tes  la dernire ligne du rowset"
                                //"Row is copied -- you are in append mode. Make changes and save or abandon new row."
#define ROWISCOPIED             "Ligne copie -- Vous tes en train d'ajouter une ligne. Modifiez et sauvegardez ou Supprimez la nouvelle ligne."
                                //"Row is being edited by another. Try again later."
#define ROWLOCKED               "Cet enregistrement est prsentement modifi par un autre utilisateur. Veuillez ressayer plus tard."
                                //"Cannot Save edits/new row when you weren't editing/adding"
#define NOTEDITING              "Impossible de sauvegarder des ajouts/modifications sans tre en mode Ajout/Modification"
                                //"Key Violation - That Key already exists."
#define KEYVIOLATION            "Duplication - Dj prsent dans l'index."
                                //"Unknown error -- "
#define UNKNOWNERROR            "Erreur inconnue -- "
                                //"You are about to delete the current row." + CHR(13) + "Click Yes to delete the current row."
#define DELETEYESNO             "Voulez-vous rellement supprimer cette ligne ?" + CHR(13) + "Appuyez sur Oui pour procder  cette suppression."
                                //"Nothing to delete!"
#define NOTHINGTODELETE         "Rien  supprimer !"
                                //"Abandoning the row will cancel the filter!"
#define ABANDONWILLCANCELFILTER "Quitter cette ligne annulera le filtre !"
                                //"Abandoning the row will cancel the locate!"
#define ABANDONWILLCANCELLOCATE "Quitter cette ligne abandonnera la recherche squentielle !"
                                //"Cannot Abandon edits/new row when you weren't editing/adding!"
#define NOTHINGTOABANDON        "Impossible d'annuler des ajouts/modifications sans tre en mode Ajout/Modification !"
                                //"No Match"
#define NOMATCH                 "Aucune ligne ne rpond au critre"
                                //"Exit from filter mode!"
#define EXITFROMFILTER          "Sortir du filtrage !"
                                //"No more matches!"
#define NOMOREMATCHES           "Aucune autre ligne ne rpond au critre !"

// ------------------------------------------------------------
// Misc Titles
                                //"Can't Add a new row!"
#define CANTADDROW              " Impossible d'ajouter une ligne !"
                                //"Can't Copy row!"
#define CANTCOPYROW             " Impossible de copier la ligne !"
                                //"Copy complete"
#define COPYCOMPLETE            " Copie effectue"
                                //"Can't Edit row!"
#define CANTEDITROW             " Impossible de modifier la ligne !"
                                //"Can't Save row!"
#define CANTSAVEROW             " Impossible de sauvegarder la ligne !"
                                //"No changes to save!"
#define NOCHANGES               " Pas de modification  sauvegarder !"
                                //"Can't Delete row!"
#define CANTDELETEROW           " Impossible de supprimer cette ligne !"
                                //"Alert"
#define ALERT                   " Attention"
                                //"Empty table"
#define EMPTYTABLETEXT          " Table vide"
                                //"Cancel Filter?"
#define CANCELFILTER            " Doit-on annuler le filtre ?"
                                //"Cancel Locate?"
#define CANCELLOCATE            " Doit-on annuler la recherche squentielle ?"
                                //"Can't abandon row!"
#define CANTABANDONROW          " Impossible d'abandonner la ligne !"
                                //"Can't set a filter!"
#define CANTSETFILTER           " Impossible d'appliquer le filtre !"
                                //"Filter"
#define FILTERTEXT              " Filtre"
                                //"Can't start a search!"
#define CANTSEARCH              " Impossible d'effectuer la recherche !"
                                //"Search"
#define SEARCH                  " Recherche"

// -----------------------------------------------------------
// kmRowState -- states:
//"Closed"
#define STATECLOSED             "Ferm"
                                //"View" // or "Browse"
#define STATEVIEW               "Vue tabulaire"
                                //"Edit"
#define STATEEDIT               "Modification"
                                //"Append"
#define STATEAPPEND             "Ajout"
                                //"Filter"
#define STATEFILTER             "Filtre"
                                //"Locate"
#define STATELOCATE             "Recherche squentielle"

// -----------------------------------------------------------
// End of header file: custButtFrench.h
// -----------------------------------------------------------


