/*****************************************************************************
   File     : messenger.cc
   Autor    : Marc Van den Berghen
 
   Provide a way to surface all windows-messages (one per Paintbox) without
   the need of an external dll (or Active-x).
 
   Dependencies : none
 
   Usage : create a new messagepb, then assign the windows-handle of the
           control you want to monitor to the window_handle property and the
           messagenumber to the wm property. Call the setup()-method, and from
           hereon, every occurence of the stated message in the monitored
           window will trigger the onkeyup event of the paintbox.
 
   Example : local mpb
             mpb=new messagepb(form)
             mpb.window_handle = form.grid1.hwnd
             mpb.wm = WM_PAINT
             mpb.setup()
 
             function wrap
               ? "The grid received a WM_PAINT message"
             return
****************************************************************************/
 
class MessagePB(oparent) of paintbox(oparent) custom
 
   * Custom Properties
   this.width        :=0
   this.height       :=0
   this.window_handle =0
   this.wm            =0
 
   * Protected properties
   this.mad          = 0
   this.bytecode     = ''
   this.wndproc      = 0
 
   * methods
   this.onkeyup   = class::wrap
   this.cleanup   = class::cleanup
   this.setup     = class::setup
 
 
   function setup()
      #define     GWL_WNDPROC         (-4)
      #define     GMEM_FIXED          0
      if this.window_handle=0
         return
      endif
      local tmp,cod,hpr,api,i
      this.bytecode=replicate(chr(0),150)
      cod= 'FFFFFFFFFFFFFFFFFFFFFFFF558BEC817D0C2B000000'
      cod+='7515FF7514FF751068010100006834120000E821000000FF7514FF7510FF750C'
      cod+='FF75086867450000E805000000C9C21000CCFF2500204000FF2504204000'
 
      extern chandle    GlobalAlloc(CUINT, clong) kernel32
      extern chandle    GlobalFree(chandle) kernel32
      extern chandle    GetCurrentProcess( cvoid ) kernel32
      extern clogical   WriteProcessMemory(chandle, cptr, cptr, clong,cptr ) kernel32
      extern clong       GetWindowLong(chandle, CINT) user32 from "GetWindowLongA"
      extern clong      SetWindowLong(chandle, CINT, CLONG) user32 from "SetWindowLongA"
      extern chandle    GetModuleHandle( cstring ) kernel32 from "GetModuleHandleA"
      extern clong      GetProcAddress(chandle, cstring) kernel32
      extern clong      GlobalLock(clong) kernel32
      this.mad=globalalloc(GMEM_FIXED,300)
      if this.mad=0
         Msgbox("Memory allocation failed","Fatal Error",0)
         return
      endif
      this.wndproc=getwindowlong(this.window_handle,GWL_WNDPROC)
      cod=stuff(cod,at('686745',cod)+2,8,class::ptrtrafo(this.wndproc))
      cod=stuff(cod,at('683412',cod)+2,8,class::ptrtrafo(this.hwnd))
      cod=stuff(cod,at('FF2500',cod)+4,8,class::ptrtrafo(this.mad))
      cod=stuff(cod,at('FF2504',cod)+4,8,class::ptrtrafo(this.mad+4))
      cod=stuff(cod,at('7D0C2B',cod)+4,8,class::ptrtrafo(this.wm))
      tmp=getmodulehandle('user32.dll')
      cod=stuff(cod,1,8,class::ptrtrafo(getprocaddress(tmp,'CallWindowProcA')))
      cod=stuff(cod,9,8,class::ptrtrafo(getprocaddress(tmp,'SendMessageA')))
      mtext = ""
      for i=0 to (len(cod)/2)-1
         this.bytecode.setbyte(i,htoi(substr(cod,(i*2)+1,2)))
      endfor
      tmp=getcurrentprocess()
      writeprocessmemory(tmp,this.mad,this.bytecode,len(this.bytecode)*2,0)
      setwindowlong(this.window_handle,GWL_WNDPROC,this.mad+12)
   return
 
   function cleanup()
      setwindowlong(this.window_handle,GWL_WNDPROC,this.wndproc)
      globalfree(this.mad)
   return
 
   function ptrtrafo(n)
      local cret,c
      c=right('00000000'+itoh(n),8)
      cret=right(c,2)+substr(c,5,2)+substr(c,3,2)+left(c,2)
   return cret
 
   function wrap(t1,t2,t3)
      local wparam,lparam
      wparam=t1
      lparam=itoh(t3)+itoh(t2)
   return
 
endclass 
 