/*  Rich - www.autotraker.com

   The big benefit of using msgPop over the dBASE msgbox os the abilities 
   to set a timeout. Otherwise the dBASE msgbox works just fine. 


   Version History	
      Date	05/23/2006
      Version 1.0

   Syntax
      intButton = msgPop(strText,[strTitle],[nType],[nSecondsToWait],[nButton]) 

   Arguments
      strText        : String value containing the text you want to appear
                       in the pop-up message box. 

      nSecondsToWait : Maximum length of time to display the pop-up message
                       box (in seconds, Optional, default=infinite)
                       Timing may not be exact.

      strTitle       : Title text string, Optional. 

      nType          : Type of buttons and icons (Numeric, Optional)
                       These determine how the message box is used. 

      nButton        : Which button receives focus. (Numeric, Optional)
                       See M_MB_DEFBUTTON 1 to 3

      IntButton      : Number of the button (Integer value) 
                       This is the value returned when the user OK's the message box. 

   The meaning of nType is determined by combining values from the 2 tables below:

   Button Types
     Value Description 
       0   OK button. 
       1   OK and Cancel buttons. 
       2   Abort, Retry, and Ignore buttons. 
       3   Yes, No, and Cancel buttons. 
       4   Yes and No buttons. 
       5   Retry and Cancel buttons. 
       6	  Cancel, Try Again, Continue	 (May be XP only)
   
   Icon Types
     Value Description 
       16  "Stop Mark" icon. 
       32  "Question Mark" icon. 
       48  "Exclamation Mark" icon. 
       64  "Information Mark" icon. 

   Possible values for IntButton, the return value:
     Value Description 
       -1  Timeout reached 
       1   OK button 
       2   Cancel button 
       3   Abort button 
       4   Retry button 
       5   Ignore button 
       6   Yes button 
       7   No button
       10  Try Again
       11  Continue


   If the user does not click a button before nSecondsToWait
   intButton is set to -1. 
         
   Example:
      ? msgPop("msgPop","Hello",16+4,5) 		Yes/No Error, wait 5 seconds
      ? msgPop("msgPop","Hello",16+4,5,2)		Yes/No Error, wait 5 seconds, second button is default
      ? msgPop("msgPop","Hello")             Plain Message box
      ? msgPop("msgPop","Hello",0,5)         Plain Message box, wait 5 seconds

   */
   #define M_MB_SYSTEMMODAL	0x00001000
   /* Use system-modal message boxes to notify the
      user of serious, potentially damaging errors 
      that require immediate attention (for example, 
      running out of memory). This flag has no effect
      on the user's ability to interact with windows
      other than those associated with hWnd.
      See MsgBox.h for additional options
   */
   #define M_MB_DEFAULT_DESKTOP_ONLY	0x00020000	
   /* The desktop currently receiving input must be a 
      default desktop; otherwise, the function fails. 
      A default desktop is one an application runs on 
      after the user has logged on.
   */

   // default button flags
   #define M_MB_DEFBUTTON1	0x00000000	//	The first button is the default button.
   #define M_MB_DEFBUTTON2	0x00000100	//	The second button is the default button.
   #define M_MB_DEFBUTTON3	0x00000200	//	The third button is the default button.

   parameters strText,strTitle,nType,nSecondsToWait,nButton
   private oShell
   if not type("strText")=="C"
      strText = 'Syntax is:'+chr(13)+;
                'intButton = msgPop(strText,[strTitle],[nType],[nSecondsToWait],[nButton])'+chr(13)+;
                'This button is msgPop("Message string","Error!",16,10)'
      strTitle = "Error!"
      nType = 16
      nSecondsToWait = 10
   endif
   if not type("strTitle")=="C"
      strTitle = ""
   endif
   if not type("nType")=="N"
      nType = 0
   endif
   if not type("nSecondsToWait")=="N"
      nSecondsToWait = 0
   endif
   if type("nButton")=="N"
      if nButton = 1
         nType += M_MB_DEFBUTTON1
      elseif nButton = 2
         nType += M_MB_DEFBUTTON2
      elseif nButton = 3
         nType += M_MB_DEFBUTTON3
      endif
   endif

   // Always make it system-modal (Recommended)
   nType += M_MB_SYSTEMMODAL

   // Always make it desktop-modal - Disables timer  (NOT Recommended)
   //nType += M_MB_DEFAULT_DESKTOP_ONLY

   oShell = new OleAutoClient("WScript.Shell")
   intButton = oShell.Popup(strText,nSecondsToWait,strTitle,nType) 
   release object oShell
return intButton


